Index: /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 373)
@@ -192,5 +192,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_2view.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 373)
@@ -186,5 +186,5 @@
 MultiviewMvRegMode        : 0                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 0.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 373)
@@ -196,5 +196,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_3view.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 373)
@@ -188,5 +188,5 @@
 MultiviewMvRegMode        : 0                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 0.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_balloons.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_balloons.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_balloons.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_gtfly.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_gtfly.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_gtfly.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_kendo.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_kendo.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_kendo.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_news.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_news.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_news.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_poznanhall.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_poznanhall.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_poznanhall.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_poznanstreet.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_poznanstreet.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_poznanstreet.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_undodancer.cfg
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_undodancer.cfg	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/cfg/IBPsetting_undodancer.cfg	(revision 373)
@@ -199,5 +199,5 @@
 MultiviewMvRegMode        : 1                                      # use original depth maps for regularizing inter-view motion vector
 MultiviewMvRegLambdaScale : 1.0                                    # lambda scale factor for inter-view motion vector regularization
-MultiviewResPred          : 1                                      # inter-view residual prediction (0:off, 1:on)
+MultiviewResPred          : 1                                      # advanced inter-view residual prediction (0:off, 1:on)
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
Index: /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 373)
@@ -383,5 +383,9 @@
 #endif
 #if H3D_IVRP
+#if QC_ARP_D0177
+  ("MultiviewResPred", m_nUseAdvResPred,           (UInt)0, "usage of Advanced residual prediction" )
+#else
   ("MultiviewResPred", m_uiMultiviewResPredMode,   (UInt)0, "usage of inter-view residual prediction" )
+#endif
 #endif
 
@@ -917,6 +921,10 @@
 #endif
 #if H3D_IVRP
+#if QC_ARP_D0177
+  xConfirmPara     ( m_nUseAdvResPred < 0 || m_nUseAdvResPred > 1 , "0<=ARP<=1" );
+#else
   xConfirmPara    ( m_uiMultiviewResPredMode > 1,                                     "MultiviewResPred must be less than or equal to 1" );
   xConfirmPara    ( m_uiMultiviewResPredMode > 0 && m_uiPredDepthMapGeneration == 0 , "MultiviewResPred > 0 requires PredDepthMapGen > 0" );
+#endif
 #endif
   if( m_bUsingDepthMaps )
@@ -1672,4 +1680,7 @@
   printf("IVSEnable: %d ", m_bUseIVS);
 #endif
+#if QC_ARP_D0177
+  printf(" ARP:%d  " , m_nUseAdvResPred  );
+#endif
   printf("\n");
 
Index: /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncCfg.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncCfg.h	(revision 373)
@@ -217,6 +217,10 @@
   Double    m_dMultiviewMvRegLambdaScale;                     ///< lambda scale for multiview motion vectors regularization
 #endif
-#if H3D_IVRP
+#if H3D_IVRP 
+#if QC_ARP_D0177
+  UInt      m_nUseAdvResPred;
+#else
   UInt      m_uiMultiviewResPredMode;          ///< using multiview residual prediction
+#endif
 #endif
 
Index: /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncTop.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/App/TAppEncoder/TAppEncTop.cpp	(revision 373)
@@ -223,5 +223,10 @@
 #endif
 #if H3D_IVRP
+#if QC_ARP_D0177
+    m_acTEncTopList[iViewIdx]->setUseAdvRP                     ( iViewIdx ? m_nUseAdvResPred             : 0   );
+    m_acTEncTopList[iViewIdx]->setARPStepNum                   ( iViewIdx ? QC_ARP_WFNR                  : 1   );
+#else
     m_acTEncTopList[iViewIdx]->setMultiviewResPredMode         ( m_uiMultiviewResPredMode );
+#endif
 #endif
 
@@ -560,6 +565,11 @@
       m_acTEncDepthTopList[iViewIdx]->setMultiviewMvRegLambdaScale    ( 0.0 );
 #endif
-#if H3D_IVRP
-      m_acTEncDepthTopList[iViewIdx]->setMultiviewResPredMode         ( 0 );
+#if H3D_IVRP 
+#if QC_ARP_D0177
+    m_acTEncDepthTopList[iViewIdx]->setUseAdvRP                          ( 0 );
+    m_acTEncDepthTopList[iViewIdx]->setARPStepNum                        ( 1 );
+#else
+    m_acTEncDepthTopList[iViewIdx]->setMultiviewResPredMode         ( 0 );
+#endif
 #endif
 
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/ContextTables.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/ContextTables.h	(revision 373)
@@ -487,4 +487,14 @@
 #endif
 };
+#if QC_ARP_D0177
+#define NUM_ARPW_CTX                  4       ///< number of context models for generalized residual prediction weighting factor
+static const UChar 
+INIT_ARPW[3][NUM_ARPW_CTX] = 
+{
+  { 154 , 154 , 154 , 154 }, 
+  { 154 , 154 , 154 , 154 }, 
+  { 154 , 154 , 154 , 154 }, 
+};
+#endif
 
 #if LGE_EDGE_INTRA_A0070
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp	(revision 373)
@@ -225,4 +225,7 @@
   m_pbResPredFlag      = NULL;
 #endif
+#if QC_ARP_D0177
+  m_puhARPW           = NULL;
+#endif
 #if LGE_EDGE_INTRA_A0070
   m_pucEdgeCode         = NULL;
@@ -301,4 +304,7 @@
     m_pbResPredAvailable = (Bool*  )xMalloc(Bool,   uiNumPartition);
     m_pbResPredFlag      = (Bool*  )xMalloc(Bool,   uiNumPartition);
+#if QC_ARP_D0177
+    m_puhARPW            = new UChar[ uiNumPartition];
+#endif
 #endif
     m_puhLumaIntraDir    = (UChar* )xMalloc(UChar,  uiNumPartition);
@@ -463,4 +469,7 @@
     if ( m_pDvInfo            ) { xFree(m_pDvInfo);             m_pDvInfo           = NULL; }
 #endif
+#if QC_ARP_D0177
+    if ( m_puhARPW           )  { delete[] m_puhARPW;          m_puhARPW          = NULL; }
+#endif
     if ( m_puhLumaIntraDir    ) { xFree(m_puhLumaIntraDir);     m_puhLumaIntraDir   = NULL; }
     if ( m_puhChromaIntraDir  ) { xFree(m_puhChromaIntraDir);   m_puhChromaIntraDir = NULL; }
@@ -636,4 +645,7 @@
     m_pbSDCFlag[ui] = pcFrom->getSDCFlag(ui);
 #endif
+#if QC_ARP_D0177
+    m_puhARPW[ui] = pcFrom->getARPW( ui );
+#endif
     m_puhWidth  [ui] = pcFrom->getWidth(ui);
     m_puhHeight [ui] = pcFrom->getHeight(ui);
@@ -733,4 +745,7 @@
     memset( m_pbResPredFlag            + firstElement, 0    , sizeof( Bool ) * numElements );
 #endif
+#if QC_ARP_D0177
+    memset( m_puhARPW                  + firstElement, 0    , sizeof( UChar ) * numElements  );
+#endif
   }
   
@@ -875,4 +890,7 @@
       m_pbResPredFlag[ui]      = 0;
 #endif
+#if QC_ARP_D0177
+      m_puhARPW[ui] = 0;
+#endif
       m_puhLumaIntraDir[ui] = 2;
       m_puhChromaIntraDir[ui] = 0;
@@ -985,4 +1003,7 @@
   memset( m_pbResPredAvailable, 0, iSizeInBool  );
   memset( m_pbResPredFlag,      0, iSizeInBool  );
+#endif
+#if QC_ARP_D0177
+  memset( m_puhARPW,            0, iSizeInUchar  );
 #endif
   memset( m_puhLumaIntraDir,    2, iSizeInUchar );
@@ -1102,4 +1123,7 @@
       m_pbResPredFlag     [ui] = pcCU->m_pbResPredFlag     [ uiPartOffset + ui ];
 #endif
+#if QC_ARP_D0177
+      m_puhARPW           [ui] = pcCU->getARPW( uiPartOffset+ui );
+#endif
 #if RWTH_SDC_DLT_B0036
       m_pbSDCFlag         [ui] = pcCU->m_pbSDCFlag         [ uiPartOffset + ui ];
@@ -1224,4 +1248,7 @@
   m_pbResPredFlag       = pcCU->getResPredFlag ()     + uiPart;
 #endif
+#if QC_ARP_D0177
+  m_puhARPW             = pcCU->getARPW() + uiPart;
+#endif
   m_puhLumaIntraDir     = pcCU->getLumaIntraDir()     + uiPart;
   m_puhChromaIntraDir   = pcCU->getChromaIntraDir()   + uiPart;
@@ -1392,4 +1419,7 @@
   m_pbResPredFlag      = pcCU->getResPredFlag ()          + uiAbsPartIdx;
 #endif
+#if QC_ARP_D0177
+  m_puhARPW           = pcCU->getARPW()                 + uiAbsPartIdx;
+#endif
   m_apiMVPIdx[eRefPicList] = pcCU->getMVPIdx(eRefPicList) + uiAbsPartIdx;
   m_apiMVPNum[eRefPicList] = pcCU->getMVPNum(eRefPicList) + uiAbsPartIdx;
@@ -1409,5 +1439,10 @@
 // Copy small CU to bigger CU.
 // One of quarter parts overwritten by predicted sub part.
-Void TComDataCU::copyPartFrom( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth )
+Void TComDataCU::copyPartFrom( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth 
+#if QC_ARP_D0177
+     ,
+    Bool bRP
+#endif
+    )
 {
   assert( uiPartUnitIdx<4 );
@@ -1446,4 +1481,7 @@
   memcpy( m_pbResPredFlag       + uiOffset, pcCU->getResPredFlag(),       iSizeInBool  );
 #endif
+#if QC_ARP_D0177
+  memcpy( m_puhARPW            + uiOffset,  pcCU->getARPW(),              iSizeInUchar );
+#endif
   memcpy( m_puhLumaIntraDir     + uiOffset, pcCU->getLumaIntraDir(),      iSizeInUchar );
   memcpy( m_puhChromaIntraDir   + uiOffset, pcCU->getChromaIntraDir(),    iSizeInUchar );
@@ -1522,5 +1560,9 @@
 
 #if LGE_EDGE_INTRA_A0070
+#if QC_ARP_D0177
+  if( !bRP && pcCU->getSlice()->getSPS()->isDepth() )
+#else
   if( getSlice()->getSPS()->isDepth() )
+#endif
   {
     memcpy( getEdgeCode( uiOffset ), pcCU->getEdgeCode(0), iSizeInUchar * LGE_EDGE_INTRA_MAX_EDGE_NUM_PER_4x4 );
@@ -1588,4 +1630,7 @@
   memcpy( rpcCU->getResPredFlag()       + m_uiAbsIdxInLCU, m_pbResPredFlag,       iSizeInBool  );
 #endif
+#if QC_ARP_D0177
+  memcpy( rpcCU->getARPW()              + m_uiAbsIdxInLCU, m_puhARPW,             iSizeInUchar );
+#endif
   memcpy( rpcCU->getLumaIntraDir()      + m_uiAbsIdxInLCU, m_puhLumaIntraDir,     iSizeInUchar );
   memcpy( rpcCU->getChromaIntraDir()    + m_uiAbsIdxInLCU, m_puhChromaIntraDir,   iSizeInUchar );
@@ -1718,4 +1763,7 @@
   memcpy( rpcCU->getResPredAvail()      + uiPartOffset, m_pbResPredAvailable,  iSizeInBool  );
   memcpy( rpcCU->getResPredFlag()       + uiPartOffset, m_pbResPredFlag,       iSizeInBool  );
+#endif
+#if QC_ARP_D0177
+  memcpy( rpcCU->getARPW()              + uiPartOffset, m_puhARPW,            iSizeInUchar );
 #endif
   memcpy( rpcCU->getLumaIntraDir()      + uiPartOffset, m_puhLumaIntraDir,     iSizeInUchar );
@@ -2709,5 +2757,20 @@
   return uiCtx;
 }
-
+#if QC_ARP_D0177
+UInt TComDataCU::getCTXARPWFlag( UInt uiAbsPartIdx )
+{
+  TComDataCU* pcTempCU;
+  UInt        uiTempPartIdx;
+  UInt        uiCtx = 0;
+  
+  pcTempCU = getPULeft( uiTempPartIdx, m_uiAbsIdxInLCU + uiAbsPartIdx );
+  uiCtx    = ( pcTempCU ) ? ((pcTempCU->getARPW( uiTempPartIdx )==0)?0:1) : 0;
+  
+  pcTempCU = getPUAbove( uiTempPartIdx, m_uiAbsIdxInLCU + uiAbsPartIdx );
+  uiCtx   += ( pcTempCU ) ? ((pcTempCU->getARPW( uiTempPartIdx )==0)?0:1): 0;
+  
+  return uiCtx;
+}
+#endif
 #if LGE_ILLUCOMP_B0045
 UInt TComDataCU::getCtxICFlag( UInt uiAbsPartIdx )
@@ -3632,5 +3695,5 @@
 #endif //H3D_NBDV
 
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   Bool bDVAvail = true;
 #endif
@@ -3689,5 +3752,5 @@
     cDisInfo.m_aVIdxCan[0] = 0;
 #endif
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
     bDVAvail = false;
 #endif
@@ -3752,5 +3815,5 @@
   iPdmDir[1] = iPdmInterDir; 
 #endif // H3D_NBDV
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   if (m_pcSlice->getSPS()->getMultiviewResPredMode()==1 && iPdmDir[0] && !bNoPdmMerge && cCurPS == SIZE_2Nx2N && bDVAvail)
   {
@@ -7278,6 +7341,9 @@
 TComDataCU::getResidualSamples( UInt uiPartIdx, Bool bRecon, TComYuv* pcYuv )
 {
+#if !QC_ARP_D0177
   TComResidualGenerator*  pcResidualGenerator = m_pcSlice->getSPS()->getResidualGenerator();
   ROFRS( pcResidualGenerator, false );
+#endif
+
 #if H3D_NBDV
   DisInfo cDisInfo;
@@ -7308,5 +7374,4 @@
 #if !QC_CU_NBDV_D0181
   getDisMvpCandNBDV( 0, 0,  &cDisInfo, false );  
-
   if( cDisInfo.iN == 0)
 #else
@@ -7326,4 +7391,13 @@
   }
   else
+#if QC_ARP_D0177
+  if(m_pcSlice->getSPS()->getUseAdvRP())  
+  {
+     m_pePartSize[0] = m_peSaved;
+     return true;
+  }
+  else
+    return false;
+#else
   {
     Bool bAvailable = pcResidualGenerator->getResidualSamples( this, uiPartIdx, pcYuv, cDisInfo.m_acMvCand[0], bRecon );       
@@ -7331,4 +7405,5 @@
     return bAvailable;
   }
+#endif
 #else
   return pcResidualGenerator->getResidualSamples( this, uiPartIdx, pcYuv, bRecon ); 
@@ -7336,5 +7411,11 @@
 }
 #endif
-
+#if QC_ARP_D0177
+Void TComDataCU::setARPWSubParts ( UChar w, UInt uiAbsPartIdx, UInt uiDepth )
+{
+  assert( sizeof( *m_puhARPW) == 1 );
+  memset( m_puhARPW + uiAbsPartIdx, w, m_pcPic->getNumPartInCU() >> ( 2 * uiDepth ) );
+}
+#endif
 #if LGE_EDGE_INTRA_A0070
 Void TComDataCU::reconPartition( UInt uiAbsPartIdx, UInt uiDepth, Bool bLeft, UChar ucStartPos, UChar ucNumEdge, UChar* pucEdgeCode, Bool* pbRegion )
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDataCU.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDataCU.h	(revision 373)
@@ -214,5 +214,7 @@
   Bool*         m_pbResPredFlag;      ///< array of residual prediction flags
 #endif
-
+#if QC_ARP_D0177
+  UChar*        m_puhARPW;
+#endif
 #if LGE_EDGE_INTRA_A0070
   UChar*        m_pucEdgeCode;          ///< array of edge code
@@ -301,6 +303,7 @@
   
   /// compute scaling factor from POC difference
+#if !QC_ARP_D0177
   Int           xGetDistScaleFactor   ( Int iCurrPOC, Int iCurrRefPOC, Int iColPOC, Int iColRefPOC );
-  
+#endif
   Void xDeriveCenterIdx( PartSize eCUMode, UInt uiPartIdx, UInt& ruiPartIdxCenter );
   Bool xGetCenterCol( UInt uiPartIdx, RefPicList eRefPicList, int iRefIdx, TComMv *pcMv );
@@ -316,5 +319,8 @@
   // create / destroy / initialize / copy
   // -------------------------------------------------------------------------------------------------------------------
-  
+#if QC_ARP_D0177
+  Int           xGetDistScaleFactor   ( Int iCurrPOC, Int iCurrRefPOC, Int iColPOC, Int iColRefPOC );
+#endif  
+
   Void          create                ( UInt uiNumPartition, UInt uiWidth, UInt uiHeight, Bool bDecSubCu, Int unitSize
 #if ADAPTIVE_QP_SELECTION
@@ -337,5 +343,10 @@
 #endif
   );
-  Void          copyPartFrom          ( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth );
+  Void          copyPartFrom          ( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth 
+#if QC_ARP_D0177
+      ,
+      Bool bRP = false
+#endif
+  );
   
   Void          copyToPic             ( UChar uiDepth );
@@ -585,4 +596,11 @@
   Bool          getResidualSamples( UInt uiPartIdx, Bool bRecon, TComYuv* pcYuv = 0 );
 #endif
+#if QC_ARP_D0177
+  UChar*        getARPW          ()                        { return m_puhARPW;               }
+  UChar         getARPW          ( UInt uiIdx )            { return m_puhARPW[uiIdx];        }
+  Void          setARPW          ( UInt uiIdx, UChar w )   { m_puhARPW[uiIdx] = w;           }
+  Void          setARPWSubParts  ( UChar w, UInt uiAbsPartIdx, UInt uiDepth );
+  Double        getARPWFactor    ( UInt uiIdx );
+#endif
   // -------------------------------------------------------------------------------------------------------------------
   // member functions for accessing partition information
@@ -705,5 +723,7 @@
   UInt          getCtxResPredFlag               ( UInt   uiAbsPartIdx                                 );
 #endif
-  
+#if QC_ARP_D0177
+  UInt          getCTXARPWFlag                 ( UInt   uiAbsPartIdx                                 );
+#endif  
   UInt          getSliceStartCU         ( UInt pos )                  { return m_uiSliceStartCU[pos-m_uiAbsIdxInLCU];                                                                                          }
   UInt          getEntropySliceStartCU  ( UInt pos )                  { return m_uiEntropySliceStartCU[pos-m_uiAbsIdxInLCU];                                                                                   }
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDepthMapGenerator.h
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 373)
@@ -80,5 +80,5 @@
 
   UInt      getPdm  ()                            { if( m_aacActiveSPS[0][1] ) { return m_aacActiveSPS[0][1]->getPredDepthMapGeneration(); } return 0; }
-#if H3D_IVRP
+#if H3D_IVRP & !QC_ARP_D0177
   UInt      getResPrd ()                          { if( m_aacActiveSPS[0][1] ) { return m_aacActiveSPS[0][1]->getMultiviewResPredMode  (); } return 0; }
 #endif
Index: /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComInterpolationFilter.cpp
===================================================================
--- /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 372)
+++ /branches/HTM-6.2-dev2-Qualcomm/source/Lib/TLibCommon/TComInterpolationFilter.cpp	(revision 373)
@@ -72,5 +72,24 @@
   { -2, 10, 58, -2 }
 };
-
+#if QC_ARP_D0177
+const Short TComInterpolationFilter::m_lumaFilterARP[4][NTAPS_LUMA_ARP] =
+{
+  {64,  0},
+  {48, 16},
+  {32, 32},
+  {16, 48}
+};
+const Short TComInterpolationFilter::m_chromaFilterARP[8][NTAPS_CHROMA_ARP] =
+{
+  {64,  0},
+  {56,  8},
+  {48, 16},
+  {40, 24},
+  {32, 32},
+  {24, 40},
+  {16, 48},
+  {8,  56}
+};
+#endif
 // ====================================================================================================================
 // Private member functions
@@ -320,5 +339,10 @@
  * \param  isLast     Flag indicating whether it is the last filtering operation
  */
-Void TComInterpolationFilter::filterHorLuma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast )
+Void TComInterpolationFilter::filterHorLuma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast 
+#if QC_ARP_D0177
+    ,
+    Bool filterType
+#endif
+    )
 {
   assert(frac >= 0 && frac < 4);
@@ -330,5 +354,10 @@
   else
   {
-    filterHor<NTAPS_LUMA>(src, srcStride, dst, dstStride, width, height, isLast, m_lumaFilter[frac]);
+#if QC_ARP_D0177
+    if(filterType)
+      filterHor<NTAPS_LUMA_ARP>(src, srcStride, dst, dstStride, width, height, isLast, m_lumaFilterARP[frac]);
+    else
+#endif
+      filterHor<NTAPS_LUMA>(src, srcStride, dst, dstStride, width, height, isLast, m_lumaFilter[frac]);
   }
 }
@@ -347,5 +376,10 @@
  * \param  isLast     Flag indicating whether it is the last filtering operation
  */
-Void TComInterpolationFilter::filterVerLuma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast )
+Void TComInterpolationFilter::filterVerLuma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast
+#if QC_ARP_D0177
+    ,
+    Bool filterType
+#endif
+    )
 {
   assert(frac >= 0 && frac < 4);
@@ -357,5 +391,10 @@
   else
   {
-    filterVer<NTAPS_LUMA>(src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilter[frac]);    
+#if QC_ARP_D0177
+    if(filterType)
+      filterVer<NTAPS_LUMA_ARP>(src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilterARP[frac]);    
+    else
+#endif
+      filterVer<NTAPS_LUMA>(src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_lumaFilter[frac]);    
   }
 }
@@ -373,5 +412,10 @@
  * \param  isLast     Flag indicating whether it is the last filtering operation
  */
-Void TComInterpolationFilter::filterHorChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast )
+Void TComInterpolationFilter::filterHorChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isLast
+#if QC_ARP_D0177
+    ,
+    Bool filterType
+#endif
+    )
 {
   assert(frac >= 0 && frac < 8);
@@ -383,4 +427,9 @@
   else
   {
+#if QC_ARP_D0177
+    if(filterType)
+      filterHor<NTAPS_CHROMA_ARP>(src, srcStride, dst, dstStride, width, height, isLast, m_chromaFilterARP[frac]);   
+    else
+#endif
     filterHor<NTAPS_CHROMA>(src, srcStride, dst, dstStride, width, height, isLast, m_chromaFilter[frac]);
   }
@@ -400,5 +449,10 @@
  * \param  isLast     Flag indicating whether it is the last filtering operation
  */
-Void TComInterpolationFilter::filterVerChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast )
+Void TComInterpolationFilter::filterVerChroma(Pel *src, Int srcStride, Short *dst, Int dstStride, Int width, Int height, Int frac, Bool isFirst, Bool isLast
+#if QC_ARP_D0177
+    ,
+    Bool filterType
+#endif
+    )
 {
   assert(frac >= 0 && frac < 8);
@@ -410,5 +464,10 @@
   else
   {
-    filterVer<NTAPS_CHROMA>(src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilter[frac]);    
+#if QC_ARP_D0177
+    if(filterType)
+      filterVer<NTAPS_CHROMA_ARP>(src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilterARP[frac]);  
+    else
+#endif
+      filterVer<NTAPS_CHROMA>(src, srcStride, dst, dstStride, width, height, isFirst, isLast, m_chromaFilter[frac]);    
   }
 }
